'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var style = {
  container: {
    position: 'relative',
    width: '100%',
    height: 58,
    textAlign: 'center',
    borderBottom: '1px solid #667D94',
    color: 'white',
    cursor: 'pointer'
  },
  badge: {
    position: 'absolute',
    right: 24,
    padding: '2px 8px',
    zIndex: 100,
    top: 4,
    backgroundColor: '#E91E63',
    borderRadius: '40%',
    fontSize: '.75rem',
    fontWeight: 600
  },
  name: {
    textTransform: 'uppercase',
    fontSize: '0.65rem'
  },
  icon: {
    height: 24,
    paddingTop: 12
  }
};

var NavLink = function (_Component) {
  _inherits(NavLink, _Component);

  function NavLink(props) {
    _classCallCheck(this, NavLink);

    var _this = _possibleConstructorReturn(this, (NavLink.__proto__ || Object.getPrototypeOf(NavLink)).call(this, props));

    _this.indicatorStyle = function (match, side) {
      return {
        height: 58,
        width: match || _this.state.hovered ? 4 : 0,
        position: 'absolute',
        backgroundColor: 'rgb(79, 195, 247)',
        left: side === 'left' ? 0 : 'auto',
        right: side === 'right' ? 0 : 'auto'
      };
    };

    _this.backgroundColor = function (match) {
      return match || _this.state.hovered ? '#667D94' : 'transparent';
    };

    _this.handleLinkSelect = function () {
      var _this$props = _this.props,
          id = _this$props.id,
          name = _this$props.name,
          url = _this$props.url,
          onSelect = _this$props.onSelect;

      onSelect({ id: id, name: name, url: url });
    };

    _this.handleHover = function () {
      return _this.setState({ hovered: true });
    };

    _this.handleBlur = function () {
      return _this.setState({ hovered: false });
    };

    _this.state = { hovered: false };
    return _this;
  }

  _createClass(NavLink, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          side = _props.side,
          badge = _props.badge,
          url = _props.url,
          name = _props.name,
          icon = _props.icon,
          color = _props.color;


      return _react2.default.createElement(_reactRouterDom.Route, { path: url, strict: true, children: function children(_ref) {
          var match = _ref.match;
          return _react2.default.createElement(
            'div',
            {
              className: 'nav-link__container',
              style: _extends({}, style.container, {
                backgroundColor: _this2.backgroundColor(match)
              }),
              onMouseEnter: _this2.handleHover,
              onMouseLeave: _this2.handleBlur,
              onClick: _this2.handleLinkSelect
            },
            _react2.default.createElement('div', {
              className: 'nav-link__indicator',
              style: _this2.indicatorStyle(match, side)
            }),
            !!badge && _react2.default.createElement(
              'div',
              {
                className: 'nav-link__badge',
                style: style.badge },
              badge
            ),
            _react2.default.createElement(_reactFontawesome2.default, {
              name: icon,
              className: 'nav-link__icon',
              style: _extends({}, style.icon, { color: match ? 'rgb(79, 195, 247)' : 'white' })
            }),
            _react2.default.createElement(
              'div',
              {
                className: 'nav-link__name',
                style: style.name },
              name
            )
          );
        } });
    }
  }]);

  return NavLink;
}(_react.Component);

NavLink.propTypes = {
  id: _propTypes2.default.number.isRequired,
  name: _propTypes2.default.string.isRequired,
  url: _propTypes2.default.string.isRequired,
  icon: _propTypes2.default.string.isRequired,
  badge: _propTypes2.default.number,
  side: _propTypes2.default.string,
  onSelect: _propTypes2.default.func.isRequired
};

exports.default = NavLink;