'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _NavLink = require('../navLink/NavLink');

var _NavLink2 = _interopRequireDefault(_NavLink);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var style = {
  menu: {
    fontFamily: 'Roboto, sans-serif',
    width: 108,
    color: 'white',
    backgroundColor: '#36526D',
    zIndex: 99,
    position: 'absolute',
    top: 0,
    bottom: 0,
    overflowY: 'auto',
    overflowX: 'hidden',
    boxShadow: '0 3px 6px rgba(0,0,0,0.16), 0 3px 6px rgba(0,0,0,0.23)'
  }
};

var SideMenu = function (_Component) {
  _inherits(SideMenu, _Component);

  function SideMenu() {
    _classCallCheck(this, SideMenu);

    return _possibleConstructorReturn(this, (SideMenu.__proto__ || Object.getPrototypeOf(SideMenu)).apply(this, arguments));
  }

  _createClass(SideMenu, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          links = _props.links,
          position = _props.position,
          onSelectLink = _props.onSelectLink;

      var side = position || 'left';

      var componentPosition = {
        left: side === 'left' ? 0 : 'auto',
        right: side === 'right' ? 0 : 'auto'
      };

      return _react2.default.createElement(
        'div',
        {
          className: 'side-menu__container',
          style: _extends({}, style.menu, componentPosition) },
        links.map(function (link) {
          return _react2.default.createElement(_NavLink2.default, _extends({
            key: link.id,
            side: side
          }, link, {
            onSelect: onSelectLink
          }));
        })
      );
    }
  }]);

  return SideMenu;
}(_react.Component);

SideMenu.propTypes = {
  links: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    id: _propTypes2.default.number.isRequired,
    name: _propTypes2.default.string.isRequired,
    url: _propTypes2.default.string.isRequired,
    icon: _propTypes2.default.string.isRequired,
    badge: _propTypes2.default.number
  })).isRequired,
  position: _propTypes2.default.string,
  onSelectLink: _propTypes2.default.func.isRequired
};

exports.default = SideMenu;